#property  copyright "ANG3110@latchess.com"
//-----------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 DodgerBlue//Lime
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 SlateGray
#property indicator_color5 SlateGray
//-------------------------------------
extern int Points = 40;
extern double Percent = 0;
extern bool chHL = true;
extern bool Texts = true;
//------------------------
double zza[],zzb[],zz0[],hm,lm,ha[],la[];
double fxH[],fxL[],di;
int fs,f0,fm,ai,bi;
double HL,HLp,HL1,k,k0;
//***************************************
int init() 
{
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexStyle(2,DRAW_LINE,0,2);
    SetIndexBuffer(0,zza);
    SetIndexBuffer(1,zzb);
    SetIndexBuffer(2,zz0);
    SetIndexEmptyValue(2,0.0);
    SetIndexBuffer(3,ha);
    SetIndexBuffer(4,la);
    SetIndexBuffer(5,fxH);
    SetIndexBuffer(6,fxL);
   
   if (chHL==false) 
   {
     SetIndexDrawBegin(3,2*Bars); 
     SetIndexDrawBegin(4,2*Bars); 
   }

   if (Texts) 
   {
     ObjectCreate("kZZfx0",OBJ_TEXT,0,Time[0],Close[0]); 
     ObjectCreate("kZZfx1",OBJ_TEXT,0,Time[0],Close[0]+0.0004);
   }
   
   if (Points!=0 && Percent==0) di=Points*Point;

   return(0); 
}
//-----------------------------------------------
int deinit(){ ObjectsDeleteAll(0,21); return(0);}
//********************************************************
int start() {
  int i,n;
  int counted_bars=IndicatorCounted();
  if (counted_bars<0) {Print("Indicator Error (Counted bars < 0)!" ); return(-1); }
  if (Bars<100) {Print("Indicator Error (Bars < 100)!" ); return(-1); }
  int cbi=Bars-2;
  if (counted_bars>2) cbi=Bars-counted_bars-1;
//======================================================================================================================
  for (i=cbi; i>=0; i--) 
  {
    //-----------------Functions------------------------------
    fxH[i]=High[i];  
    fxL[i]=Low[i];
    //--------------------------------------------------------
  }
//==============================================================
  for (i=cbi; i>=0; i--) 
  {
    //-------------------------------------------------
    if (Points!=0 && Percent!=0) return(0);
    if (Points==0 && Percent!=0) di=NormalizeDouble(Percent*Close[i]/100,3);
    //------------------Trigger-------------------------------
    if (i>Bars-5) {hm=Close[i]; lm=hm; ai=i; bi=i+1; fs=0;}
//------------------------------------------------------
    if (fxH[i]-fxL[i]>=di) 
    {
      if ((fxH[i]+fxL[i])/2>=(ha[i+1]+la[i+1])/2) 
      {
        hm=fxH[i]; 
        lm=hm-di; 
        
        if (fs==2 && ai!=bi) 
        {
          for (n=ai; n>=bi; n--) zzb[n]=fxH[ai]*(n-bi)/(ai-bi)+fxL[bi]*(n-ai)/(bi-ai);
          if (Texts) 
          {
            HLp=HL; 
            HL=MathAbs(High[ai]-Low[bi]);
            if (HLp!=0) k=HL/HLp;
            ObjectCreate("kZZfx"+Time[bi],OBJ_TEXT,0,Time[bi],Low[bi]-0.0004);
            ObjectSetText("kZZfx"+Time[bi]," "+DoubleToStr(k,2),8,"Arial",Yellow); 
          }
        }
        ai=i; 
        fs=1;
      } 
      else 
      {
        lm=fxL[i]; 
        hm=lm+di; 
        
        if (fs==1 && ai!=bi) 
        {
          for (n=bi; n>=ai; n--) zza[n]=fxH[ai]*(n-bi)/(ai-bi)+fxL[bi]*(n-ai)/(bi-ai);
          if (Texts) 
          {
            HLp=HL; 
            HL=MathAbs(High[ai]-Low[bi]);
            if (HLp!=0) k=HL/HLp;
            ObjectCreate("kZZfx"+Time[ai],OBJ_TEXT,0,Time[ai],High[ai]+0.0007);
            ObjectSetText("kZZfx"+Time[ai]," "+DoubleToStr(k,2),8,"Arial",Yellow); 
          }
        } 
        bi=i; 
        fs=2;
      }
    } 
    else
    //----------------------------1---------------------------------
    if (fxH[i]>hm) 
    {
      hm=fxH[i]; 
      lm=hm-di;     
      if (fs==2 && ai!=bi) 
      {
        for (n=ai; n>=bi; n--) zzb[n]=fxH[ai]*(n-bi)/(ai-bi)+fxL[bi]*(n-ai)/(bi-ai); 
        if (Texts) 
        {
          HLp=HL; 
          HL=MathAbs(High[ai]-Low[bi]);
          if (HLp!=0) k=HL/HLp;
          ObjectCreate("kZZfx"+Time[bi],OBJ_TEXT,0,Time[bi],Low[bi]-0.0004);
          ObjectSetText("kZZfx"+Time[bi]," "+DoubleToStr(k,2),8,"Arial",Yellow);
        }
      } 
      ai=i; 
      fs=1;
    }
    else
    //-----------------------------2--------------------------------
    if (fxL[i]<lm) 
    {
      lm=fxL[i]; 
      hm=lm+di;   

      if (fs==1 && ai!=bi) 
      {
        for (n=bi; n>=ai; n--) zza[n]=fxH[ai]*(n-bi)/(ai-bi)+fxL[bi]*(n-ai)/(bi-ai);
        if (Texts) 
        {
          HLp=HL; 
          HL=MathAbs(High[ai]-Low[bi]);
          if (HLp!=0) k=HL/HLp;
          ObjectCreate("kZZfx"+Time[ai],OBJ_TEXT,0,Time[ai],High[ai]+0.0007);
          ObjectSetText("kZZfx"+Time[ai]," "+DoubleToStr(k,2),8,"Arial",Yellow);
        }
      } 
      bi=i; 
      fs=2;
    }
    //----------------------------------------------------------------
    ha[i]=hm; 
    la[i]=lm;
    //---------------------------------------------------------------- 
    //====================i0==============================================================================
    
    if (i==0) 
    {
      if (ai!=0 || bi!=0) 
      {
        for (n=0; n<=ai+1; n++) if (ha[n]>ha[n+1]) {ai=n; break;}
        for (n=0; n<=bi+1; n++) if (la[n]<la[n+1]) {bi=n; break;}
      }

      for (n=bi; n>=ai; n--) zza[n]=fxH[ai]*(n-bi)/(ai-bi)+fxL[bi]*(n-ai)/(bi-ai); 
      for (n=ai; n>=bi; n--) zzb[n]=fxH[ai]*(n-bi)/(ai-bi)+fxL[bi]*(n-ai)/(bi-ai);

      if (fs==1) 
      {
        if (ai!=0) for (n=ai; n>=0; n--) zz0[n]=fxH[ai]*(n-0)/(ai-0)+Close[0]*(n-ai)/(0-ai);
        if (ai==0) for (n=bi; n>=0; n--) zz0[n]=0.0;
      }
      
      if (fs==2) 
      {
        if (bi!=0) {for (n=bi; n>=0; n--) zz0[n]=Close[0]*(n-bi)/(0-bi)+fxL[bi]*(n-0)/(bi-0);}
        if (bi==0) {for (n=ai; n>=0; n--) zz0[n]=0.0;}
      }
//-------------------------------------------------------------

      if (Texts) 
      {

        HL1=MathAbs(fxH[ai]-fxL[bi]);
        if (HL!=0) k=HL1/HL;

        if (fs==1) 
        {
          ObjectMove("kZZfx1",0,Time[ai],High[ai]+0.0006);
          k0=MathAbs((fxH[ai]-Close[0])/HL1);
          if (ai!=0) 
          {
            ObjectMove("kZZfx0",0,Time[0],Low[0]-0.0003);
            ObjectSetText("kZZfx0"," "+DoubleToStr(k0,2),8,"Arial",Orange);  
          }
          else ObjectMove("kZZfx0",0,Time[0],0);
        }

        if (fs==2) 
        {
          ObjectMove("kZZfx1",0,Time[bi],Low[bi]-0.0003);
          k0=MathAbs((fxL[bi]-Close[0])/HL1);
          if (bi!=0) 
          {
            ObjectMove("kZZfx0",0,Time[0],High[0]+0.0006);
            ObjectSetText("kZZfx0"," "+DoubleToStr(k0,2),8,"Arial",Orange);
          }
          else ObjectMove("kZZfx0",0,Time[0],0); 
        }
        
        ObjectSetText("kZZfx1"," "+DoubleToStr(k,2),8,"Arial",Lime);
      }//-- Text
      //--------------------------------------------
    }//-- i0
    //--------------------------------------------
    //Comment("fs = ",fs,"\n","ai = ",ai,"\n","bi = ",bi);
  } //-- for
  return(0); 
}
//*************************************************************************************************